
#include <stdio.h>            // Recommended over iostream for saving space
#include <propeller.h> 
#include <stdint.h>
#include <string.h>
#include <simpletools.h>
#include <simpletext.h>

#define TXPIN          30
#define RXPIN          31
#define BAUDRATE      115200  

#include "fdserial.h"

#define EXTERNAL
#include "CogC_Test.h"
#include "CogC_Test1.h"

void Start_CogC_Test(volatile void *parptr)
{
        extern unsigned int _load_start_CogC_Test_cog[];
    #if defined(__PROPELLER_XMM__) || defined(__PROPELLER_XMMC__)
        load_cog_driver_xmm(_load_start_CogC_Test_cog, 496, (uint32_t *)parptr);
    #else
        cognew(_load_start_CogC_Test_cog, parptr);
    #endif
}

struct CogC_Test_Par CogC_Par; 
struct CogC_Test_Par *pCogC_Par = &CogC_Par;
struct CogC_Test_Mailbox* pMbx = &(CogC_Par.CogC_Mbx);
 
int main(void)
{
    int ndx = 0;
    int Knt = 0;
    int lastKnt = -1;
    int * pData = pMbx->MBoxData;
    
    fdserial* fds = fdserial_open(RXPIN, TXPIN, 0, BAUDRATE*2);
    waitcnt(_CNT + _CLKFREQ/2);
   
    for(ndx = 0; ndx < 10; ndx ++)
        pMbx -> MBoxData[ndx] = ndx;
    pMbx->WaitTime= CLKFREQ/5;
    pMbx->Ready = 0;
    dprint(fds, "Starting Cog   WaitTime = %d\r", pMbx->WaitTime);      
    waitcnt(_CNT + _CLKFREQ);    
    Start_CogC_Test((void*) pCogC_Par);
    waitcnt(_CNT + _CLKFREQ);
    
    for(;;)
    {
           Knt = pMbx->Ready;
          // Knt = pMbx->MBoxData[9];
            
            // I would like to do this loop only if the 
            // Ready >0  perferably == 1
            // but can't seem to reset Ready See below
            // while (pMbx->Ready != 0)
            //; 
            if(Knt  > lastKnt)  
            {
                lastKnt = Knt;
            
                dprint(fds, "K:%d ", Knt)  ;               
                for(ndx = 0; ndx < 5; ndx ++)\
                {
                        dprint(fds,"n:%d-%d  ", ndx, pMbx->MBoxData[ndx]);
                        // this shows I can modify certain mailbox values 
                        // This is GOOD
                        if(pMbx->MBoxData[ndx] > 100)
                            pMbx->MBoxData[ndx] = 1;
                }
                // this line doen't print correclty or doesn't get incremened 
                // by the cog. -- see cogc code lines 37-41
                dprint(fds,"n:%d-%d  ", 9, pMbx->MBoxData[9]); 
                
                dprint(fds, "LK:%d ", lastKnt)  ;
                dprint(fds, "R:%d", pMbx->Ready)  ;
                dprint(fds, "-\r");  
                    // The following does not reset the  Ready flag
                    // This is BAD 
                 if(pMbx->Ready != 0)
                 {
                         pMbx->Ready = 0;
                         lastKnt = 0;
                  }   
                  // Does not work without a minimum  wait time              
                 waitcnt(_CNT + _CLKFREQ/4);
          } 
           
     }                              
     return 0;
}

